Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## com.trolltech.qt.gui
Class QWidgetAction

    java.lang.Object
      com.trolltech.qt.internal.QSignalEmitterInternal
          com.trolltech.qt.QSignalEmitter
              com.trolltech.qt.QtJambiObject
                  com.trolltech.qt.core.QObject
                      com.trolltech.qt.gui.QAction
                          com.trolltech.qt.gui.QWidgetAction

All Implemented Interfaces:
  QtJambiInterface

    public class QWidgetAction

extends QAction

The `QWidgetAction` class extends `QAction` by an interface for inserting custom widgets into action based containers, such as toolbars. Most actions in an application are represented as items in menus or buttons in toolbars. However sometimes more complex widgets are necessary. For example a zoom action in a word processor may be realized using a `QComboBox` in a `QToolBar`, presenting a range of different zoom levels. `QToolBar` provides `QToolBar::insertWidget()` as convenience function for inserting a single widget. However if you want to implement an action that uses custom widgets for visualization in multiple containers then you have to subclass `QWidgetAction`.

If a `QWidgetAction` is added for example to a `QToolBar` then `QWidgetAction::createWidget()` is called. Reimplementations of that function should create a new custom widget with the specified parent.

If the action is removed from a container widget then `QWidgetAction::deleteWidget()` is called with the previously created custom widget as argument. The default implementation hides the widget and deletes it using QObject::deleteLater().

If you have only one single custom widget then you can set it as default widget using `setDefaultWidget()`. That widget will then be used if the action is added to a `QToolBar`, or in general to an action container that supports `QWidgetAction`. If a `QWidgetAction` with only a default widget is added to two toolbars at the same time then the default widget is shown only in the first toolbar the action was added to. `QWidgetAction` takes over ownership of the default widget.

Note that it is up to the widget to activate the action, for example by reimplementing mouse event handlers and calling `QAction::trigger()`.

Mac OS X: If you add a widget to a menu in the application's menu bar on Mac OS X, the widget will be added and it will function but with some limitations:

1. The widget is reparented away from the `QMenu` to the native menu view. If you show the menu in some other place (e.g. as a popup menu), the widget will not be there.
2. Focus/Keyboard handling of the widget is not possible.
3. Due to Apple's design, mouse tracking on the widget currently does not work.
4. Connecting the `triggered()` signal to a slot that opens a modal dialog will cause a crash in Mac OS X 10.4 (known bug acknowledged by Apple), a workaround is to use a QueuedConnection instead of a DirectConnection.

See also:
  `QAction`, `QActionGroup`, and `QWidget`.

Nested Class Summary

Nested classes/interfaces inherited from class com.trolltech.qt.gui.QAction
`QAction.ActionEvent, QAction.MenuRole`

Nested classes/interfaces inherited from class com.trolltech.qt.QSignalEmitter
`QSignalEmitter.AbstractSignal, QSignalEmitter.Signal0, QSignalEmitter.Signal1, QSignalEmitter.Signal2, QSignalEmitter.Signal3, QSignalEmitter.Signal4, QSignalEmitter.Signal5, QSignalEmitter.Signal6, QSignalEmitter.Signal7, QSignalEmitter.Signal8, QSignalEmitter.Signal9`

Nested classes/interfaces inherited from class com.trolltech.qt.internal.QSignalEmitterInternal
`com.trolltech.qt.internal.QSignalEmitterInternal.AbstractSignalInternal`

Field Summary

Fields inherited from class com.trolltech.qt.gui.QAction
`changed, hovered, toggled, triggered`

Fields inherited from class com.trolltech.qt.internal.QSignalEmitterInternal
`currentSender`

Constructor Summary
`QWidgetAction(QObject parent)` Constructs an action with `parent`.

Method Summary
`protected java.util.List` | `createdWidgets()` Returns the list of widgets that have been using `createWidget()` and are currently in use by widgets the action has been added to.
`protected QWidget` | `createWidget(QWidget parent)` This function is called whenever the action is added to a container widget that supports custom widgets.
`QWidget` | `defaultWidget()` Returns the default widget.
`protected void` | `deleteWidget(QWidget widget)` This function is called whenever the action is removed from a container widget that displays the action using a custom `widget` previously created using `createWidget()`.
`void` | `releaseWidget(QWidget widget)` Releases the specified `widget`.
`QWidget` | `requestWidget(QWidget parent)` Returns a widget that represents the action, with the given `parent`.
`void` | `setDefaultWidget(QWidget w)` Sets `widget` to be the default widget.

Methods inherited from class com.trolltech.qt.gui.QAction
`actionGroup, activate, associatedWidgets, autoRepeat, data, font, hover, icon, iconText, isCheckable, isChecked, isEnabled, isIconVisibleInMenu, isSeparator, isVisible, menu, menuRole, parentWidget, setActionGroup, setAutoRepeat, setCheckable, setChecked, setData, setDisabled, setEnabled, setFont, setIcon, setIcon, setIconText, setIconVisibleInMenu, setMenu, setMenuRole, setSeparator, setShortcut, setShortcut, setShortcut, setShortcutContext, setShortcuts, setShortcuts, setStatusTip, setText, setToolTip, setVisible, setWhatsThis, shortcut, shortcutContext, shortcuts, showStatusText, showStatusText, statusTip, text, toggle, toolTip, trigger, whatsThis`

Methods inherited from class com.trolltech.qt.core.QObject
`childEvent, children, connectSlotsByName, customEvent, disposeLater, dumpObjectInfo, dumpObjectTree, dynamicPropertyNames, event, eventFilter, findChild, findChild, findChild, findChildren, findChildren, findChildren, findChildren, indexOfProperty, installEventFilter, isWidgetType, killTimer, moveToThread, objectName, parent, properties, property, removeEventFilter, setObjectName, setParent, setProperty, startTimer, timerEvent, toString, userProperty`

Methods inherited from class com.trolltech.qt.QtJambiObject
`dispose, disposed, equals, finalize, reassignNativeResources, tr, tr, tr`

Methods inherited from class com.trolltech.qt.QSignalEmitter
`blockSignals, disconnect, disconnect, signalsBlocked, signalSender, thread`

Methods inherited from class com.trolltech.qt.internal.QSignalEmitterInternal
`__qt_signalInitialization`

Methods inherited from class java.lang.Object
`clone, getClass, hashCode, notify, notifyAll, wait, wait, wait`

Methods inherited from interface com.trolltech.qt.QtJambiInterface
`disableGarbageCollection, nativeId, nativePointer, reenableGarbageCollection, setJavaOwnership`

Constructor Detail

### QWidgetAction

    public QWidgetAction(QObject parent)

  Constructs an action with `parent`.

Method Detail

### createdWidgets

    protected final java.util.List createdWidgets()

  Returns the list of widgets that have been using `createWidget()` and are currently in use by widgets the action has been added to.

### defaultWidget

    public final QWidget defaultWidget()

  Returns the default widget.

See also:
  `setDefaultWidget()`.

### releaseWidget

    public final void releaseWidget(QWidget widget)

  Releases the specified `widget`.

  Container widgets that support actions call this function when a widget action is removed.

See also:
  `requestWidget()`, `deleteWidget()`, and `defaultWidget()`.

### requestWidget

    public final QWidget requestWidget(QWidget parent)

  Returns a widget that represents the action, with the given `parent`.

  Container widgets that support actions can call this function to request a widget as visual representation of the action.

See also:
  `releaseWidget()`, `createWidget()`, and `defaultWidget()`.

### setDefaultWidget

    public final void setDefaultWidget(QWidget w)

  Sets `widget` to be the default widget. The ownership is transferred to `QWidgetAction`. Unless `createWidget()` is reimplemented by a subclass to return a new widget the default widget is used when a container widget requests a widget through `requestWidget()`.

See also:
  `defaultWidget()`.

### createWidget

    protected QWidget createWidget(QWidget parent)

  This function is called whenever the action is added to a container widget that supports custom widgets. If you don't want a custom widget to be used as representation of the action in the specified `parent` widget then 0 should be returned.

See also:
  `deleteWidget()`.

### deleteWidget

    protected void deleteWidget(QWidget widget)

  This function is called whenever the action is removed from a container widget that displays the action using a custom `widget` previously created using `createWidget()`. The default implementation hides the `widget` and schedules it for deletion using QObject::deleteLater().

See also:
  `createWidget()`.

Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD